= How do I add PMD CPD duplicate code detection to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

Part of [http://pmd.sourceforge.net/ PMD] is the PMD CPD (copy/paste detector) that can be used to search for duplicate 
code in Java, JSP, C, C++, Fortran, or PHP source code files. Such code might be suitable for refactoring or 
abstracting in order to reduce the amount of code that must be maintained or the number of places a single change must 
be made. CPD can ignore differences in literals (e.g., same method with different hard-coded constants) and differences 
in identifiers (e.g., same method but different variable names). It can also be configured to ignore duplicated blocks 
of less than a certain size.

== For Maven projects ==

To use PMD CPD in a Maven project, add the following lines to your `pom.xml` file:

{{{
#!text/xml
<project>
  ...
  <reporting>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-pmd-plugin</artifactId>
        <configuration>
          <minimumTokens>50</minimumTokens> 
        </configuration>
      </plugin>
    </plugins>
  </reporting>
  ...
</project>
}}}

You can invoke the PMD CPD analysis with `mvn pmd:cpd`, or PMD CPD will report its findings as part of the Maven site 
report (`mvn site`).

== For Ant builds ==

To use PMD CPD in an Ant project, add the following files to a directory in your source tree (`tools/pmd-<%= node['tools']['pmd-bin']['version'] %>`):
 * `lib/`
   * `asm-3.1.jar`
   * `jaxen-1.1.1.jar`
   * `pmd-<%= node['tools']['pmd-bin']['version'] %>.jar`
 * `cpdhtml.xslt`

If you prefer to keep the PMD libraries outside your source tree, change the locations for the `tools.dir` and/or
the `pmd.lib.dir` properties in the lines below. 

Add the following lines to your `build.xml` file. `build.dir`, `compile.classpath`, `junit.lib.dir`, `src.dir`, 
and `test.src.dir` should be set appropriately. 

{{{
#!text/xml
	<property name="tools.dir" location="tools"/>
	<property name="pmd.dir" location="${tools.dir}/pmd-<%= node['tools']['pmd-bin']['version'] %>"/>
	<property name="pmd.lib.dir" location="${pmd.dir}/lib"/>
	<property name="pmd.cpd.xsl.file" location="${pmd.dir}/cpdhtml.xslt"/>

	<property name="pmd.build.dir" location="${build.dir}/pmd"/>

	<property name="report.dir" location="${build.dir}/reports"/>
	<property name="cpd.report.dir" location="${report.dir}/cpd"/>

	<property name="cpd.minimum.tokens" value="50"/>
	<property name="cpd.ignore.literals" value="true"/>
	<property name="cpd.ignore.identifiers" value="true"/>
	
	<path id="test.classpath">
		<path refid="compile.classpath"/>
		<fileset dir="${junit.lib.dir}" includes="**/*.jar"/>
	</path>
	<path id="pmd.classpath">
		<path refid="test.classpath"/>
		<pathelement path="${pmd.build.dir}"/>
		<fileset dir="${pmd.lib.dir}" includes="**/*.jar"/>
	</path>

	<taskdef name="cpd" classname="net.sourceforge.pmd.cpd.CPDTask" classpathref="pmd.classpath"/>

	<target name="cpd" description="Search for cut-and-pasted code">
		<property name="cpd.report.xml" location="${cpd.report.dir}/cpd.xml"/>
		<mkdir dir="${cpd.report.dir}"/>
		<cpd minimumTokenCount="${cpd.minimum.tokens}" format="xml" outputFile="${cpd.report.xml}"
			ignoreLiterals="${cpd.ignore.literals}" ignoreIdentifiers="${cpd.ignore.identifiers}">
			<fileset dir="${src.dir}" includes="**/*.java"/>
			<fileset dir="${test.src.dir}" includes="**/*.java"/>
		</cpd>
		
		<property name="cpd.report.html" location="${cpd.report.dir}/index.html"/>
		<xslt in="${cpd.report.xml}" style="${pmd.cpd.xsl.file}" out="${cpd.report.html}"/>
		<echo message="CPD report is at ${cpd.report.html}"/>
	</target>
}}}

== Customizing ==

=== For Ant ===
The `cpd.minimum.tokens` property controls the minimum length of the matched sections of code. A token
tranlates roughly to a word, operator, function name, etc.

If the `cpd.ignore.literals` property is set to `true`, code which is similar other than literal values
will still match.
 
If the `cpd.ignore.identifiers` property is set to `true`, code which is similar other than 
variable names will still match.

=== For Maven ===

The `minimumTokens` property controls the minimum length of the matched sections of code. A token
tranlates roughly to a word, operator, function name, etc.

There does not seem to be a way to control the literal and identifier matching in Maven as there is in Ant. 
Ignoring literals seems to be off, while ignoring identifiers is on.

=== More information ===

 * [http://maven.apache.org/plugins/maven-pmd-plugin/ Maven options]
 * [http://pmd.sourceforge.net/cpd.html Ant options]
 
<%= node['trac']['wiki']['footer'] %>